package com.xperia64.diyedit.metadata;

public class Checksums {
	
	//Check if the checksums are correct
	public static int readChecksums(byte[] b)
	{
		
		int checkSumOne=0;
		int checkSumTwo=0;
		String hex1 = fixHex((Integer.toHexString(byteForAddition(b[19]))))+fixHex((Integer.toHexString(byteForAddition(b[18]))))+fixHex((Integer.toHexString(byteForAddition(b[17]))))+fixHex((Integer.toHexString(byteForAddition(b[16]))));
		String hex2 = fixHex((Integer.toHexString(byteForAddition(b[23]))))+fixHex((Integer.toHexString(byteForAddition(b[22]))))+fixHex((Integer.toHexString(byteForAddition(b[21]))))+fixHex((Integer.toHexString(byteForAddition(b[20]))));
		for(int i = 0; i<256; i++)
		{
			if(i>=16&&i<23)
			{
				checkSumOne+=0;
			}else{
			checkSumOne+=byteForAddition(b[i]);
			}
		}
		for(int i = 256; i<b.length; i++)
		{
			checkSumTwo+=byteForAddition(b[i]);
		}
		String hex11 = Integer.toHexString(checkSumOne);
		if(hex11.length()<8)
		{
			int l = hex11.length();
			for(int i = 0; i<8-l; i++)
			{
				hex11="0"+hex11;
			}
		}
		String hex21 = Integer.toHexString(checkSumTwo);
		if(hex21.length()<8)
		{
			int l = hex21.length();
			for(int i = 0; i<8-l; i++)
			{
				hex21="0"+hex21;
			}
		}
		if(hex11.equals(hex1)&&hex21.equals(hex2))
		{
			return 0;
		}else if(!hex11.equals(hex1)&&hex21.equals(hex2)){
			return 1;
		}else if(hex11.equals(hex1)&&!hex21.equals(hex2)){
			return 2;
		}else{
			return 3;
		}
	}
	// Fix single digit hex codes
	private static String fixHex(String x) {
		if(x.length()==1)
		{
			x="0"+x;
		}
		return x;
	}
	// Write checksums to the byte array and optionally to the file
	public static byte[] writeChecksums(byte[] b)
	{
		int checkSumOne=0;
		int checkSumTwo=0;
		for(int i = 16; i<23; i++)
		{
			b[i]=0;
		}
		for(int i = 0; i<256; i++)
		{
			checkSumOne+=byteForAddition(b[i]);
		}
		for(int i = 256; i<b.length; i++)
		{
			checkSumTwo+=byteForAddition(b[i]);
		}
		String hex11 = Integer.toHexString(checkSumOne);
		if(hex11.length()<8)
		{
			int l = hex11.length();
			for(int i = 0; i<8-l; i++)
			{
				hex11="0"+hex11;
			}
		}
		String hex21 = Integer.toHexString(checkSumTwo);
		if(hex21.length()<8)
		{
			int l = hex21.length();
			for(int i = 0; i<8-l; i++)
			{
				hex21="0"+hex21;
			}
		}
		b[16]=(byte) Integer.parseInt(hex11.substring(6,8),16); // Set checksums
		b[17]=(byte) Integer.parseInt(hex11.substring(4,6),16);
		b[18]=(byte) Integer.parseInt(hex11.substring(2,4),16); 
		b[19]=(byte) Integer.parseInt(hex11.substring(0,2),16);
		b[20]=(byte) Integer.parseInt(hex21.substring(6,8),16);
		b[21]=(byte) Integer.parseInt(hex21.substring(4,6),16);
		b[22]=(byte) Integer.parseInt(hex21.substring(2,4),16);
		b[23]=(byte) Integer.parseInt(hex21.substring(0,2),16);
		return b;
	}
	// Fix bytes because -128 is needed for some reason in java
	private static int byteForAddition(byte b)
	{
		int[] negBytes=new int[128];
		int pos=0;
		for(int i = 128; i>=1; i--)
		{
			negBytes[pos]=i;
			pos++;
		}
		int b2=b;
		if(b<0)
		{
			b2=127+negBytes[(b*-1)-1];
		}
		return b2;
		
	}
	
} 

