package com.xperia64.diyedit.metadata;


// Read and write game metadata
public class GameMetadata extends Metadata {
	
	public GameMetadata(String f)
	{
		super(f);
	}
	
	public GameMetadata(byte[] b)
	{
		super(b);
	}
	// Returns the command the game tells the player
	public String getCommand()
	{
		String cmd="";
		boolean finished=false;
		for(int i = 58845; i<58857; i++)
		{
			if(file[i]==0)
			{
				finished=true;
			}
			if(!finished)
			{
			cmd+=(char)file[i];
			}
		}
		return cmd;
	}
	// Sets the command the game tells the player
	public void setCommand(String cmd)
	{
		char[] c = cmd.toCharArray();
		for(int i = 58845; i<58857; i++)
		{
			if(i-58845<c.length)
			{
				file[i]=(byte)c[i-58845];
			}else{
				file[i]=0x00;
			}
		}
	}
	// Reads length of game, 0 is short, 1 is long, 2 is boss
	public byte getLength()
	{
		return file[58885];	
	}
	// Writes length of game, 0 is short, 1 is long, 2 is boss
	public void setLength(byte l)
	{
		file[58885]= l;
	}
	// Reads "cartridge" shape of game, 9 cartridges with values 0-8
	public byte getCartType()
	{
		//0 Round top
		//1 Top with hole
		//2 Square top with indents
		//3 Round top with vents at bottom
		//4 Zig-zag sides
		//5 Flat top with notches
		//6 Angled top with small indents on sides
		//7 GBA style with protruding top
		//8 Star
		return file[166];
	}
	// Writes "cartridge" shape of game, 9 cartridges with values 0-8
	public void setCartType(byte c)
	{
		//0 Round top
		//1 Top with hole
		//2 Square top with indents
		//3 Round top with vents at bottom
		//4 Zig-zag sides
		//5 Flat top with notches
		//6 Angled top with small indents on sides
		//7 GBA style with protruding top
		//8 Star
		file[166]=c;
	}
	// Reads "cartridge" color of game, 8 colors with values 0-7
	public byte getCartColor()
	{
		//0 Yellow
		//1 Light Blue
		//2 Green
		//3 Orange
		//4 Dark Blue
		//5 Red
		//6 White
		//7 Black
		return file[168];
	}
	// Writes "cartridge" color of game, 8 colors with values 0-7
	public void setCartColor(byte c)
	{
		//0 Yellow
		//1 Light Blue
		//2 Green
		//3 Orange
		//4 Dark Blue
		//5 Red
		//6 White
		//7 Black
		file[168]=c;
	}
	// Reads "cartridge" logo of game, 8 logos with values 0-7
	public byte getLogo()
	{
		//0 Pulse
		//1 Rocket
		//2 Sword
		//3 Fist
		//4 Car
		//5 Bat
		//6 Blocks
		//7 Blob
		return file[167];
	}
	// Writes "cartridge" logo of game, 8 logos with values 0-7
	public void setLogo(byte c)
	{
		//0 Pulse
		//1 Rocket
		//2 Sword
		//3 Fist
		//4 Car
		//5 Bat
		//6 Blocks
		//7 Blob
		file[167]=c;
	}
	// Reads "cartridge" logo color of game, 8 colors with values 0-7
	public byte getLogoColor()
	{
		//0 Yellow
		//1 Light Blue
		//2 Green
		//3 Orange
		//4 Dark Blue
		//5 Red
		//6 White
		//7 Black
		return file[169];
	}
	// Writes "cartridge" color of game, 8 colors with values 0-7
	public void setLogoColor(byte c)
	{
		//0 Yellow
		//1 Light Blue
		//2 Green
		//3 Orange
		//4 Dark Blue
		//5 Red
		//6 White
		//7 Black
		file[169]=c;
	}
	
	
	
	
}
