package com.xperia64.diyedit.saveutils;

import java.io.File;
import java.util.ArrayList;

import com.xperia64.diyedit.FileByteOperations;

// Handles save file operations for DS and RAW Wii saves
public class SaveHandler {

	private byte[] saveFile; // Savefile
	private byte[] mioFile;
	private byte[] sys0File;
	private byte[] sys1File;
	private String s1;
	private String s0;
	private String nam;
	private DSSave d;
	private WiiSave w;
	public SaveHandler(String savename)
	{
		
		saveFile=FileByteOperations.read(savename);
		nam=savename;
		if(saveFile.length==33554432||saveFile.length==33566720)
		{
			d = new DSSave(saveFile);
		}else if(saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408){
			s1=savename.substring(0,savename.lastIndexOf(File.separator)+1)+"SYS_0";
			s0=savename.substring(0,savename.lastIndexOf(File.separator)+1)+"SYS_1";
			if(new File(s1).exists()&&new File(s0).exists())
			{
				sys0File=FileByteOperations.read(s0);
				sys1File=FileByteOperations.read(s1);
			}
			w = new WiiSave(saveFile, sys0File, sys1File);
		}
	}
	public byte[] getMio(int mode, int mionumber) // Filename is the save file name
	{

		if(saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408)
		{
			
			return w.getMioList( mode ).get(mionumber);
		}else if(saveFile.length==33554432||saveFile.length==33566720)
		{ // dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			return d.getMioList(mode).get(mionumber);
		}else{
			return null;
		}
	}
	public void setMio(String mioname, int mionumber) // Filename is the save file name, mioname is the mio filename
	{
		//saveFile=fbo.read(filename);
		mioFile=FileByteOperations.read(mioname);
		System.out.println(mioFile.length);
		if(mioFile.length!=65536&&mioFile.length!=8192&&mioFile.length!=14336)
		{
			System.out.println("Not a mio file!");
			return;
		}
		if(saveFile.length==33554432||saveFile.length==33566720) // It's a ds save!
		{
			d.setMio(mionumber, mioFile);
			saveFile=d.saveChanges();
		}else if((saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408)&&new File(s0).exists()&&new File(s1).exists()){ // It's a wii save!
			
			w.setMio(mionumber, mioFile);
			ArrayList<byte[]> b = w.saveSetChanges();
			saveFile=b.get(0);
			sys0File=b.get(1);
			sys1File=b.get(2);
		}
	}
	public void deleteMio(int mode, int mionumber)
	{
		//saveFile=fbo.read(filename);
		if(saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408)
		{
			
			w.deleteMio(mode, mionumber);
			saveFile=w.saveChanges();
		}else if(saveFile.length==33554432||saveFile.length==33566720)
		{
			// dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			d.deleteMio(mode, mionumber);
			saveFile=d.saveChanges();
		}
	}
	public ArrayList<byte[]> getMios(int mode)
	{
		if(saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408)
		{
			
			return w.getMioList( mode );
		}else if(saveFile.length==33554432||saveFile.length==33566720)
		{ // dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			return d.getMioList(mode);
		}else{
			return null;
		}
	}
	public byte[] unlockMedals()
	{
		d.unlockMedals();
		return d.saveChanges();
		//return new DSSave(saveFile, new byte[0], 0, 0).unlockMedals();
	}
	public byte[] unlockGames()
	{
		d.unlockGames();
		return d.saveChanges();
		//return new DSSave(saveFile, new byte[0], 0, 0).unlockGames();
	}
	public byte[] unlockRecords()
	{
		d.unlockRecords();
		return d.saveChanges();
		//return new DSSave(saveFile, new byte[0], 0, 0).unlockRecords();
	}
	public byte[] unlockManga()
	{
		d.unlockManga();
		return d.saveChanges();
		//return new DSSave(saveFile, new byte[0], 0, 0).unlockManga();
	}
	public void saveChanges()
	{
		if(saveFile.length==4719808||saveFile.length==591040||saveFile.length==1033408)
		{
			FileByteOperations.write(sys0File, s0);
			FileByteOperations.write(sys1File, s1);
			FileByteOperations.write(saveFile, nam);
		}else if(saveFile.length==33554432||saveFile.length==33566720)
		{ // dsmode=0-2 (Games, Records, Comics), mionumber=0-89
			FileByteOperations.write(saveFile, nam);
		}
	}
}
